function y_est = cnntest(x,w,b,n)
% Author: P. Bhattacharya
%
%--------------------------------------------------------------------------
% This source code is provided without any warranties as published in 
% DASP book 3rd edition, copyright Wiley & Sons 2022, available at 
% https://mydasp.com/dasp. It may be used for educational purposes and not 
% for commercial applications without further permission.
%--------------------------------------------------------------------------
% dasp_chap11_ex2_CNN -> cnntest.m
% May 04, 2022, Purbaditya Bhattacharya
% Exercise for Chapter "Machine Learning for Audio"

L = length(x);
numlayers = length(w);
y_est = [];
for i = 1:L-n+1
    %% get data snippet
    x_i = x(i:i+n-1);
    %% feedforward operation
    for j = 1:numlayers
        if j == 1
            y = conv1d(x_i,w{j},b{j});
            y = max(y(:)',0);
        elseif j == numlayers
            y = y*w{j}+b{j};
        else
            y = max(y*w{j}+b{j},0);
        end
    end
    y_est = [y_est y];
end
end

%% filter function
function y = conv1d(x,w,b)
    y = zeros(size(x,1),size(x,2),size(w,4));
    for d = 1:size(w,4)
        for ch = 1:size(x,3)
            y(:,:,d) = y(:,:,d) + conv(x(:,:,ch),rot90(w(:,:,ch,d),2),'same') + b(d);
        end
    end
end