function [E,w,b] = nnfit(x,y,w,b,n)
% Author: P. Bhattacharya
%
%--------------------------------------------------------------------------
% This source code is provided without any warranties as published in 
% DASP book 3rd edition, copyright Wiley & Sons 2022, available at 
% https://mydasp.com/dasp. It may be used for educational purposes and not 
% for commercial applications without further permission.
%--------------------------------------------------------------------------
% dasp_chap11_ex1_NN -> nnfit.m
% May 04, 2022, Purbaditya Bhattacharya
% Exercise for Chapter "Machine Learning for Audio"

L = length(x);
numlayers = length(w);
%% placeholder for hidden layers
h1 = cell(1,numlayers);
h2 = cell(1,numlayers-1);
dh2 = cell(1,numlayers-1);
dh2h1 = cell(1,numlayers-1);
%% train and update
for i = 1:L-n+1
    %% get data snippet
    x_i = x(i:i+n-1);
    y_i = y(i+n-1);
    %% feedforward operation
    for j = 1:numlayers
        if j == 1
            h1{j} = x_i*w{j}+b{j};
            h2{j} = max(h1{j},0);
        elseif j == numlayers
            h1{j} = h2{j-1}*w{j}+b{j};
        else
            h1{j} = h2{j-1}*w{j}+b{j};
            h2{j} = max(h1{j},0);
        end
    end
    %% error and backpropagation
    de = -2*(y_i-h1{end});
    E = sum(de.^2);
    for j = numlayers:-1:1
        if j == numlayers
            dh2{j-1} = de*w{j}';
            dw{j} = h2{j-1}'*de;
            db{j} = de;
        elseif j == 1
            dh2h1{j} = h2{j};dh2h1{j}(dh2h1{j}>0)=1;
            dw{j} = x_i'*(dh2{j}.*dh2h1{j});
            db{j} = dh2{j}.*dh2h1{j};
        else
            dh2h1{j} = h2{j};dh2h1{j}(dh2h1{j}>0)=1;
            dh2{j-1} = (dh2{j}.*dh2h1{j})*w{j}';
            dw{j} = h2{j-1}'*(dh2{j}.*dh2h1{j});
            db{j} = dh2{j}.*dh2h1{j};
        end
        
        %% update SGD
        w{j} = w{j}-0.02*dw{j};
        b{j} = b{j}-0.001*db{j};
    end
end